--- Makefile.in.orig
+++ Makefile.in
@@ -158,7 +158,7 @@ test::
 # want things getting rebuilt after they're signed just because a dependency
 # has a later mtime because it was also signed.
 codesign::
-	@for subdir in vendor src/darwintracelib1.0 src/machista1.0 src/macports1.0 src/registry2.0 src/pextlib1.0 src/programs/daemondo ; do\
+	@for subdir in vendor src/darwintracelib1.0 src/machista1.0 src/macports1.0 src/registry2.0 src/pextlib1.0 src/programs src/port ; do\
 		echo ===\> making $@ in ${DIRPRFX}$$subdir; \
 		( cd $$subdir && $(MAKE) DIRPRFX=${DIRPRFX}$$subdir/ $@) || exit 1; \
 	done
diff --git a/src/port/Makefile.in b/src/port/Makefile.in
index 806377291..47a9746e4 100644
--- src/port/Makefile.in.orig
+++ src/port/Makefile.in
@@ -42,3 +42,6 @@ install: all mkdirs
 ifeq (darwin,@OS_PLATFORM@)
 	chmod -h 555 "${DESTDIR}${bindir}/portf"
 endif
+
+codesign:: port-tclsh
+	../codesign.sh $?
diff --git a/src/programs/Makefile.in b/src/programs/Makefile.in
index 4090e7051..662345210 100644
--- src/programs/Makefile.in.orig
+++ src/programs/Makefile.in
@@ -8,3 +8,9 @@ include $(srcdir)/../../Mk/macports.subdir.mk
 
 distclean::
 	rm -f Makefile
+
+codesign::
+	@for subdir in $(SUBDIR) ; do \
+        echo ===\> making $@ in ${DIRPRFX}$$subdir; \
+        ( cd $$subdir && $(MAKE) DIRPRFX=${DIRPRFX}$$subdir/ $@) || exit 1; \
+    done
diff --git a/vendor/Makefile.in b/vendor/Makefile.in
index 29f5ef070..5d4e59650 100644
--- vendor/Makefile.in.orig
+++ vendor/Makefile.in
@@ -43,6 +43,7 @@ all-tclx: all-tcl
 DESTROOT_TARGETS=   destroot-tcl destroot-tclx destroot-tcllib destroot-tcllibc
 CLEAN_TARGETS= clean-tcl clean-tcllib clean-tclx clean-signify
 DISTCLEAN_TARGETS= distclean-tcl distclean-tcllib distclean-tclx distclean-signify
+CODESIGN_TARGETS= signify-osx/signify tcl/unix/libtcl[89]*.dylib tcl/unix/tclsh tclx/libtclx[89]*.dylib tcl/unix/pkgs/itcl*/libitcl*.dylib tcl/unix/pkgs/tdbc[0-9]*/libtdbc*.dylib tcl/unix/pkgs/tdbcpostgres*/libtdbcpostgres*.dylib tcl/unix/pkgs/thread*/libthread*.dylib tcl/unix/pkgs/tdbcmysql*/libtdbcmysql*.dylib tcl/unix/pkgs/tdbcodbc*/libtdbcodbc*.dylib tcl/unix/pkgs/sqlite3*/libsqlite3*.dylib $(DESTROOT)$(TCL_PREFIX)/lib/tcllibc*/macosx-macports/tcllibc.dylib
 ifneq (@OS_PLATFORM@,linux)
 DESTROOT_TARGETS+=   destroot-signify
 endif
@@ -51,6 +52,7 @@ ifeq (@HAVE_DECL_CLONE_NOOWNERCOPY@,yes)
 DESTROOT_TARGETS+=   destroot-install
 CLEAN_TARGETS+= clean-install
 DISTCLEAN_TARGETS+= distclean-install
+CODESIGN_TARGETS+= install/build/install
 endif
 endif
 ifeq (@OS_PLATFORM@,darwin)
@@ -182,6 +184,6 @@ distclean: $(DISTCLEAN_TARGETS)
 	rm -f Makefile
 	rm -f tclsh
 
-codesign:: signify-osx/signify tcl/unix/libtcl[89]*.dylib tcl/unix/tclsh tclx/libtclx[89]*.dylib tcl/unix/pkgs/itcl*/libitcl*.dylib tcl/unix/pkgs/tdbc[0-9]*/libtdbc*.dylib tcl/unix/pkgs/tdbcpostgres*/libtdbcpostgres*.dylib tcl/unix/pkgs/thread*/libthread*.dylib tcl/unix/pkgs/tdbcmysql*/libtdbcmysql*.dylib tcl/unix/pkgs/tdbcodbc*/libtdbcodbc*.dylib tcl/unix/pkgs/sqlite3*/libsqlite3*.dylib $(DESTROOT)$(TCL_PREFIX)/lib/tcllibc*/macosx-macports/tcllibc.dylib
+codesign:: $(CODESIGN_TARGETS)
 	../src/codesign.sh $?
 
